# -*- coding: utf-8 -*-
"""
Created on Thu Nov  8 09:52:29 2021

@author: awa
"""

import os, sys
import time
from datetime import datetime

import matplotlib.pyplot as plt
import numpy as np
from epics import caget, caget_many, caput


def movecloser(num, step, pause=1):
    step_to_move = -1 * np.abs(step)
    for i in range(num):
        caput(delaystagemove, step_to_move)
        time.sleep(pause)
        print("delay stage at: %d" % (caget(delaystagepos)))


def movefurther(num, step, pause=1):
    step_to_move = np.abs(step)
    for i in range(num):
        caput(delaystagemove, step_to_move)
        time.sleep(pause)
        print("delay stage at: %d" % (caget(delaystagepos)))


def clockwise_halfwaveplate(num, step, pause=2):
    step_to_move = np.abs(step)
    for i in range(num):
        caput(halfwaveplatemove, step_to_move)
        time.sleep(pause)
        print("halfwaveplate at: %d" % (caget(halfwaveplatepos)))


def anticlockwise_halfwaveplate(num, step, pause=2):
    step_to_move = -1 * np.abs(step)
    for i in range(num):
        caput(halfwaveplatemove, step_to_move)
        time.sleep(pause)
        print("halfwaveplate at: %d" % (caget(halfwaveplatepos)))


timenow = datetime.now()
time_taking_data = timenow.strftime("%Y-%m-%d-%H%M")
pos_initial = 7811000  # just a reference point

posdelay = caget("WitDelay:pi:pos00")
info = (
    "halfwaveplatescan_133solenoid_faraday_com7pos3com8pos6_"
    + str(posdelay)
    + "_"
    + time_taking_data
)

savedir = "E:\\AWA data\\2021\\1109\\dataScan"
ictchannel = "AWAICTMon:Ch4"
waveformchannel1 = "AWAICTMon:wf1"
waveformchannel2 = "AWAICTMon:wf2"
waveformchannel3 = "AWAICTMon:wf3"

delaystagepos = "WitDelay:pi:pos00"
delaystagemove = "WitDelay:pi:rel00"
halfwaveplatepos = "HDR50:pi:pos12"
halfwaveplatemove = "HDR50:pi:rel12"

# Total number of steps to move the delay stage
Nstep = 90
# The number of steps for the half wave plate to rotate
# 100000 steps are about 1.3 degree
halfwaveplatestep = 100000

# Take `Npoints` points per each step, wait for 1 second after taking each point
Npoints = 10
sleep_move_stage = 3
sleep_take_data = 1


pos_array = np.zeros((Nstep, Npoints))
pos_init = caget(delaystagepos)
chargedata = np.zeros((Nstep, Npoints))
waveformdata1 = np.zeros((Nstep, Npoints, 5000))
waveformdata2 = np.zeros((Nstep, Npoints, 5000))
waveformdata3 = np.zeros((Nstep, Npoints, 5000))

for eachstep in range(Nstep):
    anticlockwise_halfwaveplate(1, halfwaveplatestep, pause=sleep_move_stage)
    for eachpoint in range(Npoints):
        pos_array[eachstep, eachpoint] = caget(halfwaveplatepos)
        # poslist.append(caget(delaystagepos))
        waveformdata1[eachstep, eachpoint, :] = caget(waveformchannel1)
        waveformdata2[eachstep, eachpoint, :] = caget(waveformchannel2)
        waveformdata3[eachstep, eachpoint, :] = caget(waveformchannel3)

        temp = caget(ictchannel)
        chargedata[eachstep, eachpoint] = temp
        print("current step: ", eachstep)
        print("current position: ", caget(halfwaveplatepos))
        print("ICT reading: ", temp)
        time.sleep(sleep_take_data)

    print("step %d, position: %d" % (eachstep, caget(delaystagepos)))

np.save(os.path.join(savedir, info + "halfwaveposition.npy"), pos_array)
np.save(os.path.join(savedir, info + "ictch4data.npy"), chargedata)
np.save(os.path.join(savedir, info + "waveformch2.npy"), waveformdata2)
np.save(os.path.join(savedir, info + "waveformch1.npy"), waveformdata1)
np.save(os.path.join(savedir, info + "waveformch3.npy"), waveformdata3)
