# -*- coding: utf-8 -*-
"""
Created on Thu Nov  8 09:52:29 2021

@author: awa
"""

import os, sys
import time
from datetime import datetime

import matplotlib.pyplot as plt
import numpy as np
from epics import caget, caget_many, caput


def movecloser(num, step, pause=1):
    step_to_move = -1 * np.abs(step)
    for i in range(num):
        caput(delaystagemove, step_to_move)
        time.sleep(pause)
        print("delay stage at: %d" % (caget(delaystagepos)))


def movefurther(num, step, pause=1):
    step_to_move = np.abs(step)
    for i in range(num):
        caput(delaystagemove, step_to_move)
        time.sleep(pause)
        print("delay stage at: %d" % (caget(delaystagepos)))


def clockwise_halfwaveplate(num, step, pause=2):
    step_to_move = np.abs(step)
    for i in range(num):
        caput(halfwaveplatemove, step_to_move)
        time.sleep(pause)
        print("halfwaveplate at: %d" % (caget(halfwaveplatepos)))


def anticlockwise_halfwaveplate(num, step, pause=2):
    step_to_move = -1 * np.abs(step)
    for i in range(num):
        caput(halfwaveplatemove, step_to_move)
        time.sleep(pause)
        print("halfwaveplate at: %d" % (caget(halfwaveplatepos)))


timenow = datetime.now()
time_taking_data = timenow.strftime("%Y-%m-%d-%H%M")
pos_initial = 7811000  # just a reference point
iris = str(caget("AWARPiPWM:SetPulseWidth"))  # between 650 and 900
info = "HWScan_iris_" + iris + "_" + time_taking_data

savedir = "E:\\AWA data\\2022\\10-12-Charge"
ictchannel = "AWAVXI11ICT:Ch1"
waveformchannel1 = "AWAVXI11ICT:wf1"
waveformchannel2 = "AWAVXI11ICT:wf2"

delaystagepos = "WitDelay:pi:pos00"
delaystagemove = "WitDelay:pi:rel00"
halfwaveplatepos = "HDR50:pi:pos12"
halfwaveplatemove = "HDR50:pi:rel12"

# Total number of steps to move the delay stage
Nstep = 10  # 45
# The number of steps for the half wave plate to rotate
# 100000 steps are about 1.3 degree
halfwaveplatestep = 2 * 100000

# Take `Npoints` points per each step, wait for 1 second after taking each point
Npoints = 5
sleep_move_stage = 3
sleep_take_data = 1


pos_array = np.zeros((Nstep, Npoints))
pos_init = caget(delaystagepos)
chargedata = np.zeros((Nstep, Npoints))
waveformdata1 = np.zeros((Nstep, Npoints, 2502))
waveformdata2 = np.zeros((Nstep, Npoints, 2502))

for eachstep in range(Nstep):
    anticlockwise_halfwaveplate(1, halfwaveplatestep, pause=sleep_move_stage)
    for eachpoint in range(Npoints):
        pos_array[eachstep, eachpoint] = caget(halfwaveplatepos)
        # poslist.append(caget(delaystagepos))
        waveformdata1[eachstep, eachpoint, :] = caget(waveformchannel1)
        waveformdata2[eachstep, eachpoint, :] = caget(waveformchannel2)

        temp = caget(ictchannel)
        chargedata[eachstep, eachpoint] = temp
        print(temp)
        print("current step: ", eachstep)
        print("current position: ", caget(halfwaveplatepos))
        print("ICT reading: ", temp)
        time.sleep(sleep_take_data)

    print("step %d, position: %d" % (eachstep, caget(delaystagepos)))

plt.plot(np.sum(pos_array, 1) / Npoints, np.sum(chargedata, 1) / Npoints)
plt.show()

np.savez(
    os.path.join(savedir, info + "npz"),
    setpoint=pos_array,
    charge=chargedata,
    chargeWF=waveformdata1,
    diodeWF=waveformdata2,
)
