# -*- coding: utf-8 -*-
"""
Created on Wed Nov  8 09:36:51 2021

@author: awa

This script takes a number of images specified by the user.

"""

import os, sys

import matplotlib.pyplot as plt
import numpy as np
from win32com import client

sys.path.append("\\".join(os.getcwd().split("\\")[:-1]))
import time
from datetime import datetime

from epics import caget, caget_many, caput

timenow = datetime.now()
time_taking_data = timenow.strftime("%Y-%m-%d-%H%M")

Npoints = 100
savedir = "E:\\AWA data\\2021\\1109\\dataScan"
pos = caget("WitDelay:pi:pos00")
info = "spectrometer_56dipole_115solenoid_" + str(pos) + "_" + time_taking_data

radcam = "13ARV1:image1:ArrayData"
radcam_img_shape = (1088, 2048)  # rad hard camera resolution is 1088x2048

imgdata = np.zeros((Npoints, 1088, 2048), dtype=np.uint16)

ictchannel = "AWAICTMon:Ch4"
waveformchannel1 = "AWAICTMon:wf1"
waveformchannel2 = "AWAICTMon:wf2"

chargedata = np.zeros((Npoints,))
waveformdata1 = np.zeros((Npoints, 5000))
waveformdata2 = np.zeros((Npoints, 5000))

# rad hard camera
for i in range(Npoints):
    img = caget("13ARV1:image1:ArrayData")
    img = img.reshape(radcam_img_shape)
    waveformdata1[i, :] = caget(waveformchannel1)
    waveformdata2[i, :] = caget(waveformchannel2)
    chargedata[i] = caget(ictchannel)
    time.sleep(1)
    print("step: ", i, "ict4: ", chargedata[i])
    imgdata[i, :, :] = img

np.save(os.path.join(savedir, info + "radcamimages.npy"), imgdata)
np.save(os.path.join(savedir, info + "ictch4data.npy"), chargedata)
np.save(os.path.join(savedir, info + "waveformch2.npy"), waveformdata2)
np.save(os.path.join(savedir, info + "waveformch1.npy"), waveformdata1)
