# -*- coding: utf-8 -*-
"""
Created on Fri Aug 26 09:20:05 2022

@author: awa
"""

# -*- coding: utf-8 -*-
"""
Created on Wed Jul  8 22:53:55 2020

@author: AWA
"""

import socket
import time

import matplotlib.pyplot as plt
import numpy as np
import pythoncom
import serial
from win32com import client

AWAPGCamera = client.Dispatch("AWAPGCamera.application")
pythoncom.CoInitialize()

ESSPowerSupply = serial.Serial()
ESSPowerSupply.baudrate = 9600
ESSPowerSupply.port = "COM36"  # replace com1 with the actual serial port

# S*Vdddd=Set scaling voltage to dddd Volts
# S*Cdddd=Set Scaling current to dddd Amps
# ?M returns mode, SN, etc
# SR put the supply in REMOTE operating mode
# PC%## to set the current output to ##% of full scale
# PV%## to set the voltage output to ##% of full scale
# MV measure the voltage output
# MC measure the current output


def Connect():
    if ESSPowerSupply.is_open:
        ESSPowerSupply.close()
    ESSPowerSupply.open()
    return


def Disconnect():
    ESSPowerSupply.close()
    return


def PowerOff():
    ESSPowerSupply.write("PC%00\r\n".encode("utf-8"))
    ESSPowerSupply.write("PV%00\r\n".encode("utf-8"))
    return


def Initialize():
    Connect()
    ESSPowerSupply.write("SR\r\n".encode("utf-8"))
    time.sleep(1)
    ESSPowerSupply.write("S*V0030\r\n".encode("utf-8"))
    time.sleep(1)
    ESSPowerSupply.write("S*C0500\r\n".encode("utf-8"))
    time.sleep(1)
    ESSPowerSupply.write("PC%00\r\n".encode("utf-8"))
    time.sleep(1)
    ESSPowerSupply.write("PV%99\r\n".encode("utf-8"))
    a = ESSPowerSupply.read_all()


def SetCurrent(I):
    pc = int(I / 500.0 * 1000)
    cmd = ("PC%" + "{}".format(pc).zfill(3) + "\r\n").encode("utf-8")
    ESSPowerSupply.write(cmd)
    a = ESSPowerSupply.read_all()


def MeasureCurrent():
    cmd = ("MC\r\n").encode("utf-8")
    ESSPowerSupply.write(cmd)
    time.sleep(1)
    a = ESSPowerSupply.read_all()
    return a


def GetPGImage():
    return np.asarray(AWAPGCamera.GetImage)


def GetCurrent():
    return float(str(MeasureCurrent()).split("Current = ", 1)[1].split("Amps", 1)[0])


def main():
    Initialize()

    currents = np.linspace(0, 320, 17)
    c2 = np.copy(currents)
    vert_pos = np.zeros(len(currents))

    for i, c in enumerate(currents):
        SetCurrent(c)
        if i < 2:
            time.sleep(10)
        else:
            time.sleep(3)
        c2[i] = GetCurrent()
        image = GetPGImage()
        vert_pos[i] = np.argmax(image.sum(axis=1))
        print(i, c2[i], vert_pos[i])

    np.savetxt("coil-1.txt", np.c_[c2, vert_pos])
    plt.plot(c2, vert_pos, "o-")
    plt.grid()
    plt.show()


main()
