# -*- coding: utf-8 -*-
"""
Created on Tue Jul 20 19:46:18 2021

@author: awa
"""
import sys

sys.path.insert(0, "F:\\2022\\pyctrl-awa\\base\\")
import time

import matplotlib.pyplot as plt
import numpy as np
from epics import caget, caput
from interface import AWAInterface


rootname = "tdcPhiScan_fullscan_YAG14"
N = 5
nshots = 5
step = 7000

# ---------------------------------------------

tstamp = time.strftime("%Y%m%d-%H%M%S")

screen = AWAInterface()

ict = 0
for i in range(nshots):
    caput("AWATrigCtrl:GetCh8.PROC", 1)
    while caget("AWATrigCtrl:GetCh8") > 0:
        caput("AWATrigCtrl:GetCh8.PROC", 1)
    ict_tmp = np.abs(caget("AWAVXI11ICT:Ch1"))
    caput("AWATrigCtrl:SetCh8", 1)
    ict = ict + ict_tmp
    print(ict_tmp)
Charge = ict / nshots


CentroidX = np.zeros((N))
CentroidY = np.zeros((N))
dCentroidX = np.zeros((N))
dCentroidY = np.zeros((N))
PhaseShifter = np.zeros((N))
print(rootname + "_" + tstamp)

power = caget("AWA:DAC0:Ch13")

for i in range(N):
    filename = (
        rootname + "_" + str("{0:03}".format(i)) + "_" + str(power) + "_" + tstamp
    )
    caput("TDC2O4PhSh:MoveRel", step)
    time.sleep(3.5)
    PhaseShifter[i] = caget("TDC2O4PhSh:Pos")
    time.sleep(0.5)
    print(PhaseShifter[i])
    _, sdata, roi = screen.get_data(n_samples=nshots, stat=True)

    #    _, sdata, roi = screen.save_data(filename, target_charge=Charge,
    #                 charge_deviation=0.3, # within +/- 10% deviation
    #                 n_samples=nshots, stat=True) # Number of samples
    CentroidX[i] = np.mean(sdata[:, 3])
    CentroidY[i] = np.mean(sdata[:, 4])
    dCentroidX[i] = np.std(sdata[:, 3])
    dCentroidY[i] = np.std(sdata[:, 4])

    time.sleep(0.5)


plt.errorbar(PhaseShifter / 1850, CentroidY, yerr=dCentroidY)
c = np.polyfit(PhaseShifter / 1850, CentroidY, 1)
print(c)

np.savez(filename, phase=PhaseShifter, ceny=CentroidY, dceny=dCentroidY)


# plt.scatter()

# plt.grid()
# plt.savefig(f'{filename}.png',dpi=100)
# plt.show()
